// Programacin en C++ para Ingenieros, Ed. Thomson Paraninfo, 2006
// Captulo 10: Ficheros



// Inclusin de libreras
#include <iostream>
#include <fstream>

using namespace std;

// Librera para la manipulacion de cadenas de caracteres
#include <string.h>

// Declaracin de tipos
typedef char id[20];

typedef struct 
{
    id nombre, apellido;
    int edad;
}persona;

int main(void) 
{
    ofstream fPers;

    // Abrimos el fichero
    fPers.open("datosPersona.bin");
    if(!fPers)
        cout << "Error abriendo el fichero" << endl;
    else
    {
        persona p;
        // Datos de la persona
        strcpy(p.nombre, "Pere");
        strcpy(p.apellido, "Soler");
        p.edad = 34;

        // Escribimos una persona
        fPers.write((char *)(& p), sizeof(p) );
		
        // Cerramos el fichero
        fPers.close();
    }	

	return 0;
}
